
# Project status

The core interfaces of *FluxTraining.jl* are stable now and it comes with a good set of features to get started.

However, there is still a lot of work to be done! This page gives some ideas for new features and improvements that could be added to *FluxTraining.jl*. If you want to have something on this list, open a GitHub issue or, better yet, a merge request.


## Features

- `ToTorch` callback: like [`ToGPU`](#) but uses [*Torch.jl*](https://github.com/FluxML/Torch.jl). Should be implemented using [*Requires.jl*](https://github.com/JuliaPackaging/Requires.jl) to forego the heavy dependency.
- [Weights&Biases](https://www.wandb.com/) backend for [`Logger`](#)
- More functional metrics, i.e. `metric(y_pred, y)` (atm the only one is `accuracy`). [Metrics implemented in fastai](https://docs.fast.ai/metrics) could be an inspiration.

## Improvements

- [`Checkpointer`](#): Add conditions for checkpointing, e.g. only save a checkpoint when validation loss is decreasing.

## Documentation

- More complete training tutorials including data pipelines